#library("timeSeries")
#library("forecast")
#library("fMarkovSwitching")
#library("tsDyn")
#library("quantmod")
#library("multicore")
#library("doMC")
#registerDoMC(cores=12)
#getDoParWorkers()


mcForecastSetar<- function (modeld, h)  {
lastseries<-modeld$model$yy

k= modeld$str$m
d= modeld$str$d
sigma_eps= sd(modeld$model.specific["residuals"][[1]])
r=tail(modeld$model.specific["coefficients"][[1]],1)
phi_low=modeld$model.specific["coefficients"][[1]][1:(k+1)]
print(phi_low)
phi_high=modeld$model.specific["coefficients"][[1]][(2+k):(length(modeld$model.specific["coefficients"][[1]])-1)]

for (i in (1:h)) {
z<-(r-(rev(lastseries)[d])) / sigma_eps
p<-pnorm(z)
if(i<=d) {p= as.numeric(rev(lastseries)[d] < r) } # the deterministic part

y_low = sum(phi_low  * c(1, rev(tail(lastseries,k)) )) * p

y_high= sum(phi_high * c(1, rev(tail(lastseries,k) ))) *(1-p)

if(d<=k & i>d&1==2){
correctionTerm= (phi_high[d+1]-phi_low[d+1])*sigma_eps*dnorm(z)
} 
else correctionTerm=0;

cat(correctionTerm,"\t")
lastseries<- c(lastseries, (y_low+y_high+correctionTerm))
}
as.numeric(tail(lastseries,h))
}

