





frcst_SETAR<-function (i,j, dat=sinf, ic="aic",...) {

	series<-head(na.contiguous(dat[,i]),  j - 1 - fwindow)
	series<-ts(series, start=start(na.contiguous(dat[,i])), frequency=12)
	#if(i==7 ){series<-ts(series[300:503], stwaart=c(1990,1), frequency=12); plot(series) }
	
	if (ic=="bic")	{
	    m=min( c( max(c(bicAR[i,j], 1)), c(8))); 
	} else m=min( c( max(c(aicAR[i,j], 1)), c(8))); 
	model<-setar(series,mH= m, mL=m,...);
	res=predict(model,n.ahead=fwindow-j+1)
	cat(i,j, "\n")
	return(res);	
	#temp[j,,i]<<-(predict(ar(series,max.order=12),n.ahead=fwindow-j+1)[[1]],rep(NA,j-1))
	}



frcst_real<-function (i,j, dat=sinf, ...) {
	series<-tail(na.contiguous(dat[,i]),  1 -j+ fwindow)
	#temp[j,,i]<<-(predict(ar(series,max.order=12),n.ahead=fwindow-j+1)[[1]],rep(NA,j-1))
	}


get_MSE <- function(dat=aAR){ 
  x<-matrix(NA,fwindow,ncol(sinf))
  ray=cbind(rep(1:ncol(sinf), each=fwindow), rep(1:fwindow,ncol(sinf)));
  eSQR<-matrix(mapply( function(i,j) {
          (dat[j,i][[1]]-realSample[j,i][[1]])^2
          } ,         
                     i=ray[,1], j=ray[,2]), c(fwindow,fwindow,ncol(sinf)))


for (k in (1:ncol(dat))) {
for (j in (1:nrow(dat)) ) {
 # x[j,k]<-sum(eSQR[j,k][[1]]^2) / length(eSQR[j,k][[1]])
    tmpS<-na.omit(sapply(eSQR[,k], function(x) x[j]))
     x[j,k]<- mean(tmpS)
}
}
return(x)
};




get_MSE.nit <- function(dat=aAR ){ ray=cbind(rep(1:ncol(sinf), each=fwindow), rep(1:fwindow,ncol(sinf)));
eSQR<-matrix(mapply( function(i,j) {(dat[j,i][[1]]-realSample.nit[j,i][[1]])^2} ,i=ray[,1], j=ray[,2]), c(fwindow,fwindow,ncol(sinf)))
x<-matrix(NA,fwindow,ncol(sinf))

for (k in (1:ncol(sinf))) {
for (j in (1:fwindow) ) {
 # x[j,k]<-sum(eSQR[j,k][[1]]^2) / length(eSQR[j,k][[1]])
    tmpS<-na.omit(sapply(eSQR[,k], function(x) x[j]))
  x[j,k]<- sum(tmpS)/length(tmpS)
}
}
return(x)
};


frcst_LSTAR<-function (i,j, dat=sinf, ic="aic") {

	series<-head(na.contiguous(dat[,i]),  j - 1 - fwindow)
	series<-ts(series, start=start(na.contiguous(dat[,i])), frequency=12)
	if (ic=="aic") model<-lstar(series,m=max(1,aicAR[i,j]))
	if (ic=="bic") model<-lstar(series,m=max(1,bicAR[i,j]))
	res=predict(model,n.ahead=fwindow-j+1)
	return(res);
	#temp[j,,i]<<-(predict(ar(series,max.order=12),n.ahead=fwindow-j+1)[[1]],rep(NA,j-1))
	}

frcst_nnetts<-function (i,j, dat=sinf,ic="aic" ,...) {
  cat(i, " ", j, "\n");
  series<-head(na.contiguous(dat[,i]),  j - 1 - fwindow)
	series<-ts(series, start=start(na.contiguous(dat[,i])), frequency=12)
	if(ic=="aic") {	model<-nnetTs(series,m=aicAR[i,j], size=3)}
	  if(ic=="bic") {	model<-nnetTs(series,m=bicAR[i,j], size=3)}
	res=predict(model,n.ahead=fwindow-j+1)
	#fason[j,i]<<-res;
  res
	#temp[j,,i]<<-(predict(ar(series,max.order=12),n.ahead=fwindow-j+1)[[1]],rep(NA,j-1))
	}
frcst_AR <- function (i,j, dat=sinf, ic="aic",...) {

	series<-head(na.contiguous(dat[,i]),  j - 1 - fwindow)
	series<-ts(series, start=start(na.contiguous(dat[,i])), frequency=12)
	model<-ar(series,...)
	aicAR[i,j]<<-model$order
	predict(model,n.ahead=fwindow-j+1)[[1]]
				 
	#temp[j,,i]<<-(predict(ar(series,max.order=12),n.ahead=fwindow-j+1)[[1]],rep(NA,j-1))
	}


frcst_ARMA<-function (i,j, dat=sinf, ic="aic",...) {

        cat(i,j, "-")
	k<<-i;
	
	series<-head(na.contiguous(dat[,i]),  j - 1 - fwindow)
	series<-ts(series, start=start(na.contiguous(dat[,i])), frequency=12)
	model<-forecast::auto.arima(series,d=0, D=0, max.p=12, max.P=0, max.Q=0, max.order=12, stepwise=F,ic=ic,...)
	if(ic=="aic") {aicARMA_AR[i,j]<<-model$arma[1];
	  aicARMA_MA[i,j]<<-model$arma[2];}
	  if(ic=="bic") {bicARMA_AR[i,j]<<-model$arma[1];
	  bicARMA_MA[i,j]<<-model$arma[2];}
	predict(model,n.ahead=fwindow-j+1)[[1]]
	
				 
	#temp[j,,i]<<-(predict(ar(series,max.order=12),n.ahead=fwindow-j+1)[[1]],rep(NA,j-1))
	}
  
  
  
  
  
  
  
get_MSE.SA <- function(dat=aAR ){ 
ray=cbind(rep(1:ncol(sinf), each=fwindow), rep(1:fwindow,ncol(sinf)));

for (i in (1:ncol(dat))) {
  # seasonal adjustment factors are added
  dat[,i]<-lapply(dat[,i],  function(x) (c(x) + tail(rep(sinfAdj[,i], len=40 ), length(x)) ))
}

eSQR<-matrix(mapply( function(i,j) {dat[j,i][[1]]-realSample[j,i][[1]]} ,i=ray[,1], j=ray[,2]), c(fwindow,fwindow,ncol(sinf)))
x<-matrix(NA,fwindow,ncol(sinf))

for (k in (1:ncol(sinf))) {
for (j in (1:fwindow) ) {
  #x[j,k]<-sum(eSQR[j,k][[1]]) / length(eSQR[j,k][[1]])
  tmpS<-na.omit(sapply(eSQR[,k], function(x) x[j]))
  x[j,k]<- sum(tmpS)/length(tmpS)
}
}
return(x)
};




get_MSE.nit.SA <- function(dat=aAR ){ ray=cbind(rep(1:ncol(sinf), each=fwindow), rep(1:fwindow,ncol(sinf)));

for (i in (1:ncol(dat))) {
  # seasonal adjustment factors are added
  dat[,i]<-lapply(dat[,i],  function(x) (c(x) + tail(rep(sinfAdj[,i], len=40 ), length(x)) ))
}


eSQR<-matrix(mapply( function(i,j) {(dat[j,i][[1]]-realSample.nit[j,i][[1]])^2} ,i=ray[,1], j=ray[,2]), c(fwindow,fwindow,ncol(sinf)))


x<-matrix(NA,fwindow,ncol(sinf))

for (k in (1:ncol(sinf))) {
for (j in (1:fwindow) ) {
  #x[j,k]<-sum(eSQR[j,k][[1]]) / length(eSQR[j,k][[1]])
  tmpS<-na.omit(sapply(eSQR[,k], function(x) x[j]))
  x[j,k]<- sum(tmpS)/length(tmpS)
}
}
return(x)
};






frcst_ARMA_P<-function (j, dat, ic="aic",...) {

  
	series<-head(na.contiguous(dat),  j - 1 - fwindow)
	series<-ts(series, start=start(na.contiguous(dat)), frequency=12)
	model<-forecast::auto.arima(series,d=0, D=0, max.p=12, max.P=0, max.Q=0, max.order=12, stepwise=F,ic=ic,...)

	predict(model,n.ahead=fwindow-j+1)[[1]]
				 
	#temp[j,,i]<<-(predict(ar(series,max.order=12),n.ahead=fwindow-j+1)[[1]],rep(NA,j-1))
	}
  
  
  frcst_ARMA_P_Call<- function(x) {
    
    matrix(apply(matrix(1:fwindow), 1, frcst_ARMA_P, dat=x))
    
    }
 
 
 frcst_LSTAR_P<-function (j, dat, ic="aic",...) {

  
	series<-head(na.contiguous(dat),  j - 1 - fwindow)
	series<-ts(series, start=start(na.contiguous(dat)), frequency=12)
	model<-tsDyn::lstar(series,m=4)

	modelres<-predict(model,n.ahead=fwindow-j+1)
	modelres
				 
	#temp[j,,i]<<-(predict(ar(series,max.order=12),n.ahead=fwindow-j+1)[[1]],rep(NA,j-1))
	}
  
  
  frcst_LSTAR_P_Call<- function(x) {
    
    matrix(apply(matrix(1:fwindow), 1, frcst_LSTAR_P, dat=x))
    
    }
 
 
 
 
# multicore::lapply ( frcst_LSTAR_P_Call, lit.sinf)
  
  
MS_For<- function (model, newIndep, nPeriods) 
{
 coeff=model@Coeff
 filtProb= model@filtProb
 coefM=coeff$indep_S
 newFiltProb<-matrix(filtProb[nrow(model@filtProb),],,1)
res<-0;

 for (i in c(1:nPeriods) ) {
newFiltProb = coeff$P %*% newFiltProb
res[i]<-(matrix(newIndep[i,],nrow=1) %*% coefM) %*% newFiltProb
  }
res
} 


MS_AR_Fit <- function (y, k.lag=12, ...) {  
X<-matrix(na.contiguous(quantmod::Lag(as.vector(y), c(0:k.lag))),,(k.lag+1))
X<- cbind( X[,1], rep(1,nrow(X)), X[,-1])
MS_Regress_Fit (X[,1], X[,-1], S=rep(1,k.lag+1), k=2)

} 



MS_AR_For<- function (model, series, nPeriods) 
{
 d= (model@sizeModel$n_S) + (model@sizeModel$n_nS) - 1
 relevant<-c(1,tail(na.contiguous(series),d))
 
 coeff=model@Coeff
 
 filtProb= model@filtProb
 coefM=coeff$indep_S
 lastFiltProb<-matrix(filtProb[nrow(model@filtProb),],,1)
res<-0;

for (i in c(1:nPeriods) ) {
lastFiltProb = coeff$P %*% lastFiltProb
res[i]<- (t(relevant)%*% coefM) %*% lastFiltProb
relevant= c(1, na.contiguous(Hmisc::Lag(relevant,-2)), res[i])
  }
res
}





get_ME <- function(dat=aAR){ 
  x<-matrix(NA,fwindow,ncol(sinf))
  ray=cbind(rep(1:ncol(sinf), each=fwindow), rep(1:fwindow,ncol(sinf)));
  eSQR<-matrix(mapply( function(i,j) {
          (dat[j,i][[1]]-realSample[j,i][[1]])
          } ,         i=ray[,1], j=ray[,2]), c(fwindow,fwindow,ncol(sinf)))


for (k in (1:ncol(dat))) {
  for (j in (1:nrow(dat)) ) {
 # x[j,k]<-sum(eSQR[j,k][[1]]^2) / length(eSQR[j,k][[1]])
  tmpS<-na.omit(sapply(eSQR[,k], function(x) x[j]))
  x[j,k]<- mean(tmpS)
  }
}
return(x)
};




# zoo - used for na.trim
library(zoo)
library(fArma)
get.best.arima <- function(x.ts, maxord=c(12,12), dlag=0)
{      
        # remove the leading and trailing NA observations
        x.ts <- na.trim(x.ts)

        # confirm we have sufficent data for a time series analysis
        if(length(x.ts) < 5 * frequency(x.ts))
                stop('In get.best.arima(x.ts, maxord=c(p,d,q,P,D,Q)): time series x.ts not sufficiently long')

        # function from Introductory Time Series with R
        best.aic <- 1e8 # a big number
        n <- length(x.ts)
        
        for(p in 1:maxord[1]) for(q in 0:maxord[2])
        {
                        theFormula= as.formula(paste("~arma(",p+dlag,",",q+dlag,")"));
                        theFixed= c( rep(0,dlag), rep(NA,p), rep(0,dlag), rep(NA, q),NA)
                        
                        fit <- fArma::armaFit(theFormula, data=x.ts, fixed=theFixed , method="CSS-ML")
                        cat(as.character(theFormula), " ", fit@fit$aic ,"\n")
                        fit.aic <- -2 * (fit@fit$loglik) + (log(n) + 1) * length(fit@fit$coef)
                        #fit.aic <-fit@fit$aic
                        if(fit.aic < best.aic)
                        
                        {
                                best.aic <- fit.aic
                                best.fit <- fit
                                best.model <- c(p,q)
                                
                        }
                        cat("best.aic:", best.aic, "  ", "fit.aic:", fit.aic, " \n")
                }
        
        return(list(best.fit,best.model,best.aic))
} 