deneme<- MS_AR_For( MS_AR_Fit(series), series, 12)
deneme<- MS_AR_For(model, series[1:100], 112)

usGDPq <- read.csv("/home/ege/Dropbox/US_GDP/usGDPq.csv")[,2]
usGDPq<- diff(log(usGDPq))
nmax=64
MSAR_forecasts<-multicore::mclapply(c(1:nmax), step_MS, series=usGDPq)
MS.result.matrix<-sapply(MSAR_forecasts, function (x) {res<- rep(NA,nmax); res[(nmax-length(x)+1):nmax]<-x; res})
MS.result.matrix<- MS.result.matrix[,nmax:1]


write.csv(data.frame(MS.result.matrix, real=tail(usGDPq, 64)),file="/home/ege/Dropbox/US_GDP/MSforecastGDP.csv")


load("/home/ege/Dropbox/FX/yen.RData")
  yenWeekly<- diff(log(yenWeekly))

nmax=52*4
model_yenWeekly<-MS_AR_Fit(head(yenWeekly, -nmax), 52)

MSAR_forecastsYen<-multicore::mclapply(c(1:156), step_MSconst, series=(yenWeekly), model=model_yenWeekly)

MS.result.matrix<- sapply(MSAR_forecastsYen, function (x) {res<- rep(NA,156); res[(156-length(x)+1):156]<-x; res})
MS.result.matrix<- MS.result.matrix[,ncol(MS.result.matrix):1]
write.csv(data.frame(MS.result.matrix, real=tail(diff(log(usGDPq)), 156)),file="/home/ege/Dropbox/FX/MSforecastyen.csv")


nmax=52*4
model_USCpi<-MS_AR_Fit(head(diff(log(USCpi)), -nmax), 12)

MSAR_USCpi<-multicore::mclapply(c(1:nmax), step_MSconst, series=diff(log(USCpi)), model=model_USCpi)

MS.result.matrix<- sapply(MSAR_USCpi, function (x) {res<- rep(NA,nmax); res[(nmax-length(x)+1):nmax]<-x; res})
MS.result.matrix<- MS.result.matrix[,ncol(MS.result.matrix):1]
write.csv(data.frame(MS.result.matrix, real=tail(diff(log(USCpi)), nmax)),file="/home/ege/Dropbox/FX/MSforecastyen.csv")


# with 2nd differences
nmax=52*4
model_USCpi2<-MS_AR_Fit(head(diff(log(USCpi), differences=1), -nmax), 12*10)

MSAR_USCpi2<-multicore::mclapply(c(1:nmax), step_MSconst, series=diff(log(USCpi), differences=1), model=model_USCpi2)

MS.result.matrix2<- sapply(MSAR_USCpi2, function (x) {res<- rep(NA,nmax); res[(nmax-length(x)+1):nmax]<-x; res})
MS.result.matrix2<- MS.result.matrix2[,ncol(MS.result.matrix):1]
write.csv(data.frame(MS.result.matrix, real=tail(diff(log(USCpi), differences=1), nmax)),file="/home/ege/Dropbox/US_CPI/MSforecastUSCPI2.csv")




#####  For CPI forecasts


models.it<- multicore::mclapply(lit.sinf, function(x) MS_AR_Fit(head(x,-fwindow)))
aMS.it<-matrix(mapply( function(i,j) MS_AR_For(models.it[[i]], head(lit.sinf[[i]],-fwindow+j-1 ), fwindow-j+1) , i=ray[,1], j=ray[,2]), fwindow)
#tmp<-tmp[fwindow:1,]

models.nit<- multicore::mclapply(lnit.sinf, function(x) MS_AR_Fit(head(x,-fwindow)))

aMS.nit <- matrix(mapply( function(i,j) 
MS_AR_For(models.nit[[i]], head(lnit.sinf[[i]],-fwindow+j-1 ), fwindow-j+1) , 
i=ray[,1], j=ray[,2]), fwindow)

